Attribute VB_Name = "ModToken"

'**********************************************
'             C P C    T O K E N
'**********************************************
'
'   ****  ****    ****
'  *      *   *  *
'  *      ****   *
'  *      *      *
'   ****  *       ****   Tools    -= XavSnap =-
'
'http://dskcenter.free.fr/CPC
'**********************************************

Public Const PVersion = "11/02/2011"

' Originals codes.


Option Explicit ' Declare all variables. (to avoid redundant public/private declaration)

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemoryStr Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, ByVal lpvSource As String, ByVal cbCopy As Long)
Public Declare Sub CopyMemoryToStr Lib "kernel32" Alias "RtlMoveMemory" (ByVal lpvDest As String, pvSource As Any, ByVal cbCopy As Long)
Public Declare Sub ClrMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal length As Long)

'// Tokenizer.
Public ZXbuffer() As Byte
Public ZxOffset As Long ' ZxBuffer pointer.
Public bASM As Boolean
Public VarsBuffer() As Byte
Public VarsOffset As Long
Public hFile As Integer
Public GRAPHIC_MODE As Boolean

Public CurNBLn As Long
Public FncString As String * 6
Public Cmp_Decay As Long
Public LastLINE As Long

Public FrtLine As Integer
Public ErrIndex As Long
Public InputLine As Long
Public Lines() As Long
Public lineCtr As Long
Public NewWord As Boolean
Public Prt_Trg As Boolean
Public bNum As Boolean
Public bHex As Boolean
Public bREM As Boolean
Public bSave As Boolean
Public bBas As Boolean

Public tLng As Byte ' Language trigger 1=EN 2=FR 3=DE
Public ComputerType As Byte ' Computer type 0=464,1=664,2=6128
Public cmp As Long

Public ASM_Buff() As Byte
Public Asm_OFF() As Long
Public ASM_lng() As Long
Public ASM_Add() As Long
Public ASM_cnt As Long
Public gAsmCNT As Long

Public Var_Array() As String

' CPC floating point number.
Type CPC_Long
        Exp As Integer ' - Exponent
        man As String ' - Mantissa
End Type

Type CPC2_Long 'GOSUB function
        Exp As Integer ' - Exponent
        man As String ' - Mantissa
End Type

Type Uint
bLow As Byte
bHig As Byte
End Type

Type Uint3
bLow As Byte
bMed As Byte
bHig As Byte
End Type

Type CPCheader ' Basic files header 128 bytes
Cpc_FileFlag As Byte
Cpc_Name As String * 8
Cpc_ATTR As String * 3
CPC_SPC1(5) As Byte
Cpc_Ftype As Byte ' 0=Basic files / 2=Binary files.
Cpc_BasLen As Uint
Cpc_OFFset As Uint3
Cpc_Flenght1 As Uint

CPC_SPC2(37) As Byte
Cpc_Flenght2 As Uint
CPC_SPC3(0) As Byte
Cpc_CRCheader As Uint

' Copy last line
'CPC_LSTline(26) As Byte
'CPC_LSTtag  As Byte
CPC_SPC4(58) As Byte
End Type

' CP/m 2.x Specification (Catalog header)
Type DirEntry
'00         user number (0 , possible values 0-15)
    User As Byte ' user 0-15
    
'01 - 0F    filename+extension (possibly filled with 0)
    root As String * 8
    ext As String * 3
    Attribut_1 As Byte
    Attribut_2 As Byte
    Attribut_3 As Byte
    Attribut_4 As Byte
    
'10         block Pointer (16)
    Block_pointer(15) As Byte

End Type
Const OFFSET_4 = 4294967296#
Const MAXINT_4 = 2147483647

Sub DecodeLine(CurLine As String)
Dim LOffset As Long
Dim Tmpstr As String

LOffset = 1

CurLine = Remove_tabs(CurLine)
If InStr(1, UCase(CurLine), "[ASM") > 0 Or InStr(1, UCase(CurLine), "[ ASM") > 0 Then bASM = True Else bASM = False

If InStr(1, UCase(CurLine), "[ROM") > 0 Or InStr(1, UCase(CurLine), "[ ROM") > 0 Then
If Not bBas Then
Select Case Val(Mid(UCase(CurLine), _
InStr(1, UCase(CurLine), "ROM") + 3, _
InStr(1, UCase(CurLine), "]") - InStr(1, UCase(CurLine), "ROM") - 3))

Case 464
frmMain.Computer.ListIndex = 0
frmMain.Status = frmMain.Status & "[ROM] tag present. CPC 464 SNA file used." & vbCrLf
Case 664
frmMain.Computer.ListIndex = 1
frmMain.Status = frmMain.Status & "[ROM] tag present. CPC 664 SNA file used." & vbCrLf
Case 6128
frmMain.Computer.ListIndex = 2
frmMain.Status = frmMain.Status & "[ROM] tag present. CPC 6128 SNA file used." & vbCrLf
End Select
End If
CurLine = Right(CurLine, Len(CurLine) - InStr(1, UCase(CurLine), "]"))

End If
If InStr(1, UCase(CurLine), "[LNG") > 0 Or InStr(1, UCase(CurLine), "[ LNG") > 0 Then

If InStr(1, UCase(CurLine), "]") - (InStr(1, UCase(CurLine), "LNG") + 3) > 0 Then
tLng = Val(Mid(UCase(CurLine), _
InStr(1, UCase(CurLine), "LNG") + 3, _
InStr(1, UCase(CurLine), "]") - InStr(1, UCase(CurLine), "LNG") - 3))
CurLine = Right(CurLine, Len(CurLine) - InStr(1, UCase(CurLine), "]"))
End If
End If

Do
 Do While Left(CurLine, 1) = " "
          CurLine = Right(CurLine, Len(CurLine) - 1)
 Loop

'Decode the line number
If Not bASM Then
    If InStr(1, CurLine, " ") = 0 Then
    Tmpstr = CurLine
    Else
    Tmpstr = Left(CurLine, InStr(1, CurLine, " ") - 1)
    End If
    If Tmpstr = "" Then LOffset = LOffset - 1: GoTo Continue
Else
    GoTo Continue2
    'LOffset = LOffset - 1
End If

If LOffset = 1 Then
    If Left(Trim(Tmpstr), 2) = "##" Then Exit Sub

    If Asc(Left(Tmpstr, 1)) < &H2F Or Asc(Left(Tmpstr, 1)) > &H3A Then Disp_Err 8
    
         If Not TestLineNbr(Tmpstr) Then
         Disp_Err 13, Chr(34) + Tmpstr + Chr(34) + " after line#" + Str(CurNBLn) + " <?" + RebuildLineNbr(Tmpstr) + "?>"
         
         On Error Resume Next
         CurNBLn = Val(RebuildLineNbr(Tmpstr))
                  Else
         On Error Resume Next
         CurNBLn = Val(Tmpstr)
         If FrtLine < 0 Then FrtLine = CurNBLn
         End If
    
    End If

Continue:

CurLine = Right(CurLine, Len(CurLine) - InStr(1, CurLine, " "))

If Left(CurLine, 1) = " " Then GoTo Continue

Continue2:

If LOffset = 1 Then
If Not bASM Then
    LastLINE = ZxOffset
    ZxOffset = ZxOffset + 4
End If
NewWord = True
Conv_SPGr (CurLine)
End If

If bASM Then CurLine = "": bASM = False
LOffset = LOffset + 1
Loop Until InStr(1, CurLine, " ") = 0

End Sub



Sub Conv_SPGr(text As String)

Dim Cnt As Long
Dim car_tmp As String * 1
Dim GrStr As String * 2
Dim RetByte As Byte
Dim Result As Long
Dim FunctTag As Boolean
Dim FFTag As Boolean
Dim NumString As String
Dim VarString As String
Dim CommTag As Byte
Dim bDEFINT As Boolean
Dim bIF As Boolean
Dim bOn As Boolean
Dim bRSX As Boolean

Dim TMPNum As String

Dim Get_V As Byte

Prt_Trg = False
TMPNum = ""
CommTag = 0
bNum = False
bHex = False
bRSX = False

FFTag = False
NewWord = True

Do While text <> ""

  car_tmp = text
  
  If car_tmp = vbTab Then car_tmp = " "
  
  If (car_tmp = " " Or car_tmp = ":") And Not (Prt_Trg Or bREM) Then NewWord = True


' RSX Trigger.
' Case of "|CPM","|DISC" or "|TAPE"
If car_tmp = "|" Or car_tmp = "" Then bRSX = True
   

Select Case car_tmp

Case ""
  Dim DecOff As Integer
  DecOff = 3
  GrStr = Mid(text, 2, 2)
  
'Specials CPC Characters.

     RetByte = Val("&h" & GrStr)
    
    
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = RetByte
    ZxOffset = ZxOffset + 1
    text = Right(text, Len(text) - DecOff)


 Case "[" 'ASM Codes!.
 
 If Not (bREM Or Prt_Trg) Then
      text = Right(text, Len(text) - 1)
     text = Get_ASM(Right(text, Len(text) - 3))
     car_tmp = ""
     If bASM Then Exit Sub
  Else
  ' Ignore this character and print the ASCII code.
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = Asc(car_tmp)
    ZxOffset = ZxOffset + 1
    text = Right(text, Len(text) - 1)
 End If

Case Else


' Change specials language chars codes.
car_tmp = Sp_Char(car_tmp, tLng)



Cmp_Decay = 1

' Retrive exponent...
'If bNum And (car_tmp = "." Or UCase(car_tmp) = "E") Then  'And car_tmp <> "-"
'TMPNum = TMPNum + car_tmp
'End If


If VarString = "" And Not bREM Then
If (Asc(car_tmp) > &H2F And Asc(car_tmp) < &H3A) Or _
(Asc(UCase(car_tmp)) > &H40 And Asc(UCase(car_tmp)) < &H47) Or _
car_tmp = "." Or car_tmp = "&" Or car_tmp = "%" Then

            If (Not Prt_Trg) And (Not bREM) And car_tmp = "&" Then
             bHex = True
            End If
            
    'If Not (Is_ChrHEX(car_tmp)) Or bHex Then
     ReDim Preserve ZXbuffer(ZxOffset)
    If TMPNum = "" Then CommTag = ZXbuffer(ZxOffset - 2)

    If Not Prt_Trg Then bNum = True: TMPNum = TMPNum + car_tmp
    
    If Not (bHex) And Is_AfHEX(car_tmp) Then bNum = False: TMPNum = ""
End If
End If

    
 If bNum Then
   
    If (Not Prt_Trg) And (Not bREM) And car_tmp <> "&" Then
      
      
       NewWord = True
      
            ' If the number is a variable indentation number A1 A2 ... Don't add the num. Tag.

            If (Not (Is_ChrHEX(car_tmp)) And (car_tmp <> "." And UCase(car_tmp) <> "E")) Or Right(Left(text, 2), 1) = " " Then
            '
            
            ' Test if the value is a string name.
            'If car_tmp = "$" Then
            'Debug.Print
            'End If
            
            
         
            ZxOffset = ZxOffset - Len(TMPNum)
            

            If bHex Then
                    Debug.Print
            End If
            
            NumString = ""
            NumString = Add_Num(TMPNum, bOn)
            
            If (Asc(Left(text, 1)) > &H2F And Asc(Left(text, 1)) < &H3A) And Right(Left(text, 2), 1) = " " Then
            Cmp_Decay = 1
            If car_tmp <> ":" Then ZxOffset = ZxOffset + 1
            End If


            For Cnt = 1 To Len(NumString)
            ReDim Preserve ZXbuffer(ZxOffset)
            ZXbuffer(ZxOffset) = Asc(Mid(NumString, Cnt, 1)): ZxOffset = ZxOffset + 1
            Next
            
             ReDim Preserve ZXbuffer(ZxOffset)
                      
             Result = GetAlg(text)
             
             If Result <> -1 Then ZXbuffer(ZxOffset) = CByte(Result) Else ZXbuffer(ZxOffset) = CByte(Asc(car_tmp))
             
             If Left(text, 1) = Chr(34) Then Cmp_Decay = 0: ZxOffset = ZxOffset - 1
             
             
             If ((Asc(car_tmp) > &H2F And Asc(car_tmp) < &H3A)) Then
              ZxOffset = ZxOffset - 1: ReDim Preserve ZXbuffer(ZxOffset)
             End If
             
            
             Debug.Print "'"; Trim(Right(text, Len(text) - 1)); "'"
             If Trim(Right(text, Len(text) - 1)) = "" Then text = ""

              TMPNum = ""
              NumString = ""
              VarString = ""
              bNum = False
              bHex = False
              CommTag = 0
              If Trim(text) = "" Then text = "": GoTo Exit_Scan Else GoTo Nxt_Word

    End If
    End If
End If

If Trim(text) = "" Then GoTo Exit_Scan

' Get COMMANDS AND FUNCTIONS ---------------------------------------------------------------------------

        If (Not Prt_Trg) And (Not bREM) And Not ((ZxOffset - 1)) Then NewWord = True
        If bSave Then NewWord = False
        Result = -1

      
      
If VarString = "" Then ' Don't get a function in a varable name. (case of: if a=dif then...)
        FFTag = False
        Result = GetFunc2(Left(text, 15))
        
        ' In case of "REMOTE" our "|REMOTE", don't Get the REM function !
        If bRSX Then Result = -1: Cmp_Decay = 1
        
        If Result <> -1 Then FFTag = True
        
        FunctTag = False
        
        If Result = -1 And Not bRSX Then Result = GetFunc(Left(text, 15))
         If Result = 250 Then
         Debug.Print
         End If
          
     ' If Result = 1 And (bREM Or Prt_Trg) Then
     '   If bREM Then bREM = False
        
     '   If Prt_Trg Then
     '   ZxOffset = ZxOffset + 1
     '    ReDim Preserve ZXbuffer(ZxOffset)
     '     ZXbuffer(ZxOffset - 1) = &H22
     '     ZXbuffer(ZxOffset) = CByte(Result)
     '   End If
     '  End If

        
        If Result <> -1 And (Prt_Trg Or bREM) Then Result = -1: Cmp_Decay = 1
        

End If

        ' Test sp. chars "=",">=" ...
        If (Not Prt_Trg) And (Result = -1) And Not bDEFINT Then Result = GetAlg(text)

        If bDEFINT Then Result = -1
        
        If Left(text, 1) = ":" And Not Prt_Trg And Not FFTag Then
            If bDEFINT Then bDEFINT = False
            Cmp_Decay = 1: Result = 1
            NewWord = True
        End If
        
        If bDEFINT Then Result = -1

'Force functions to chars in REMs
If bREM Then
    NewWord = False: Cmp_Decay = 1: Result = -1
End If



If (Result = -1 Or Prt_Trg Or Result > 237 Or (Result = 1 And Not FFTag)) Then   'Or (Not FFTag) Then

    'Cmp_Decay = 1
            
     ReDim Preserve ZXbuffer(ZxOffset)
     
    If Not Prt_Trg And Result = -1 And Not bDEFINT Then Result = GetAlg(car_tmp) ' Else Result = -1
     
     If Result <> -1 Then ZXbuffer(ZxOffset) = Result Else ZXbuffer(ZxOffset) = CByte(Asc(car_tmp))
     

' Numeric or string values -----------------------------------------------------------------------

 
If (Not bNum And Not Prt_Trg And Not bREM And Not bDEFINT) And (Result = -1 Or Result > 237 Or (Result = 1 And Not FFTag)) Then
      


      If VarString <> "" And (Not Is_ASCII(car_tmp) Or car_tmp = " ") Then

If Not bRSX Then
      '1=numeric : 2=string
      Select Case car_tmp
      Case "%"
      Add_Varstr VarString, 3
      Case "$"
      Add_Varstr VarString, 2
      Case Else
      Add_Varstr VarString, 1
      End Select
Else
      Add_Varstr VarString, 4
      bRSX = False
End If

           
       ReDim Preserve ZXbuffer(ZxOffset)
       
       If Result = -1 Then
       
       If (car_tmp <> "$" And car_tmp <> "%") Then ZXbuffer(ZxOffset) = CByte(Asc(car_tmp)) Else ZxOffset = ZxOffset - 1
       
       Else
       ZXbuffer(ZxOffset) = Result
       End If
       
        If car_tmp = " " Then ZxOffset = ZxOffset - 1
        
        If VarString = "0" Then
        Debug.Print text
        End If
        
        
            Debug.Print "$" & VarString & "$"
            VarString = ""
            CommTag = 0
            'GoTo Nxt_Word
 Else
           If Is_ASCII(car_tmp) And Result = -1 Or car_tmp = "&" Or car_tmp = "%" Then
           
           If VarString = "" Then
                 CommTag = ZXbuffer(ZxOffset - 2)
                 If ZXbuffer(ZxOffset - 1) = 20 Then ClrSpc (CommTag) Else CommTag = 0
           End If
           
           VarString = VarString + car_tmp
           
           ZxOffset = ZxOffset - 1
           
           Else
 

           VarString = ""
           CommTag = 0
                      
           End If
      End If
Else
'If VarString <> "" Then Add_Varstr (VarString): CommTag = 0: VarString = ""
  If Not bNum And (Prt_Trg Or bREM) Then ZXbuffer(ZxOffset) = CByte(Asc(car_tmp))
End If

       ReDim Preserve ZXbuffer(ZxOffset)

    If ZXbuffer(ZxOffset) = 34 Then Prt_Trg = Not Prt_Trg: If bNum Then TMPNum = "": bNum = False: bHex = False
      
    If ZXbuffer(ZxOffset) = &H29 Then
           
     If Not bNum Then
     TMPNum = ""
     bNum = False
     bHex = False
     End If
     
    End If
   
   
       If Result = 250 Or Result = 252 Or Result = 253 Then
'250 AND
''251 MOD
'252 OR
'253 XOR
''254 NOT
          ZxOffset = ZxOffset + 2
         ReDim Preserve ZXbuffer(ZxOffset)
         ZXbuffer(ZxOffset - 2) = &H20
         ZXbuffer(ZxOffset - 1) = CByte(Result)
         ZXbuffer(ZxOffset) = &H20
    End If
    
   
    ZxOffset = ZxOffset + 1
    

    text = Right(text, Len(text) - Cmp_Decay)
    
    If Not (Prt_Trg Or bREM) And VarString = "" Then
    Do While Left(text, 1) = " "
      text = Right(text, Len(text) - 1)
      NewWord = True
    Loop
    End If
    


' ------------------------------------------------
 
Else

       
  If FFTag Then
         ReDim Preserve ZXbuffer(ZxOffset)
         ZXbuffer(ZxOffset) = 255
         ZxOffset = ZxOffset + 1
  End If
        
        
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = CByte(Result)
    
    
 If Not FFTag Then
      
       If Result = 140 Then
        Prt_Trg = True
       End If


       ' DEFINT
       If Result = 142 Or Result = 143 Then
        bDEFINT = True
       End If
       
       ' IF tag -> add a space after a goto !
       ' In case of "if a=1 goto ..."
       ' IF, EVERY , AFTER , ON
       If Result = 161 Or Result = 157 Or Result = 128 Or Result = 178 Then
        bIF = True
       End If
       
       
       If Result = 178 Then
       bOn = True
       End If
       
       If car_tmp = ":" Then bIF = False: bOn = False: bRSX = False
  

       ' REM (197) and "'" (192) chars.
       If Result = 192 Or Result = 197 Then
          ' "'" at the end of line.
          If Result = 192 And ((ZxOffset - LastLINE) > 4) Then
          Debug.Print ZxOffset - LastLINE
          ZxOffset = ZxOffset + 2
            ReDim Preserve ZXbuffer(ZxOffset)
            ZXbuffer(ZxOffset - 2) = &H20
            ZXbuffer(ZxOffset - 1) = &H1
            ZXbuffer(ZxOffset) = CByte(Result)
          Else
            ReDim Preserve ZXbuffer(ZxOffset)
          ZXbuffer(ZxOffset) = CByte(Result)
          End If
        bREM = True
       End If
       
      
    If Result = 151 Then ' ELSE
         bIF = False
         ZxOffset = ZxOffset + 3
         ReDim Preserve ZXbuffer(ZxOffset)
         ZXbuffer(ZxOffset - 3) = &H20
         ZXbuffer(ZxOffset - 2) = &H1
         ZXbuffer(ZxOffset - 1) = CByte(Result)
         ZXbuffer(ZxOffset) = &H20
         ZxOffset = ZxOffset - 1
    End If
   
    If (Result = 159 Or Result = 160) And bIF Then '  GOTO/Gosub (add a space!) Optional THEN !
         bIF = False
         Debug.Print CurNBLn
          ZxOffset = ZxOffset + 1
         ReDim Preserve ZXbuffer(ZxOffset)
         ZXbuffer(ZxOffset - 1) = &H20
         ZXbuffer(ZxOffset) = CByte(Result)
    End If
 
    
    If Result = 235 Or Result = 236 Or Result = 230 Or Result = 65 Then '  TO & THEN & step & ERR
         bIF = False
          ZxOffset = ZxOffset + 1
         ReDim Preserve ZXbuffer(ZxOffset)
         ZXbuffer(ZxOffset - 1) = &H20
         ZXbuffer(ZxOffset) = CByte(Result)
    End If
     
    
    ' add a space in case of command word.
    If Result > 127 And Result <> 168 And Result <> 172 Then
    ' Don't add a space in case of:
    ' 172= Mid$
    If Mid(text, Cmp_Decay + 1, 1) <> ":" And InStr(1, text, " ") <> 0 Then
            ZxOffset = ZxOffset + 1
             ReDim Preserve ZXbuffer(ZxOffset)
             ZXbuffer(ZxOffset) = &H20
    End If
    End If


    
' REM xxxx
If (Result = 197 Or Result = 192) And ZXbuffer(ZxOffset) = &H20 Then ZxOffset = ZxOffset - 1
If Result = 140 Then ZxOffset = ZxOffset - 1
 
 End If
 
     

    
Nxt_Word:

    FFTag = False
    ZxOffset = ZxOffset + 1
    


' Jump to the next word -----------------------------------------------------------------

    If Result <> 192 And Result <> 197 And VarString = "" And Cmp_Decay <> 0 Then
        Do While Mid(text, Cmp_Decay, 1) = " "
            Cmp_Decay = Cmp_Decay + 1
        Loop
    End If
    
   
    
    text = Right(text, Len(text) - Cmp_Decay)
    
    If Not (Prt_Trg Or bREM) And VarString = "" Then
        Do While Left(text, 1) = " "
          text = Right(text, Len(text) - 1)
        Loop
    End If
    
    If (InStr(1, text, "[") <> 0) Then
    ' ASM
        Do While Left(text, 1) = " "
          text = Right(text, Len(text) - 1)
        Loop

    End If
    
End If
 
End Select

         
' Next word ---------------------------------------------------------------------------
Loop


Exit_Scan:


       If (Not Prt_Trg) And (Not bREM) And Not bNum Then ClrSpc (CommTag)
       
  
       
       
       If (Not Prt_Trg) And (Not bREM) And bNum Then
            
            
            ZxOffset = ZxOffset - Len(TMPNum)
            
            NumString = Add_Num(TMPNum, bOn)
              
            For Cnt = 1 To Len(NumString)
            ReDim Preserve ZXbuffer(ZxOffset)
            ZXbuffer(ZxOffset) = Asc(Mid(NumString, Cnt, 1))
            ZxOffset = ZxOffset + 1
            Next

                       
            
            'If (Asc(Left(text, 1)) > &H2F And Asc(Left(text, 1)) < &H3A) Then
            'text = Right(text, Len(text) - 1)
            'Cmp_Decay = 2
            'Debug.Print text
            'End If

              Result = -1
              TMPNum = ""
              NumString = ""
              VarString = ""
              bNum = False
              bHex = False
              bIF = False
              bOn = False
              CommTag = 0
           ' End If
       End If
     
If (Not Prt_Trg) And (Not bREM) And VarString <> "" Then


If CurNBLn = 1550 Then
Debug.Print
End If

     '1=numeric : 2=string
      Select Case car_tmp
      Case "%"
      Add_Varstr VarString, 3
      Case "$"
      Add_Varstr VarString, 2
      Case Else
      Add_Varstr VarString, 1
      End Select

           
       ReDim Preserve ZXbuffer(ZxOffset)
       
       If Result = -1 Then
         If (car_tmp <> "$" And car_tmp <> "%") Then ZXbuffer(ZxOffset) = CByte(Asc(car_tmp)) Else ZxOffset = ZxOffset - 1
       
        Else
         ZXbuffer(ZxOffset) = Result
       End If
       
           ' If car_tmp = " " Then
            ZxOffset = ZxOffset - 1
              
            Debug.Print "$" & VarString & "$"
            VarString = ""
            CommTag = 0
End If
       
    
    ' End Of Line
    ' Line header ---------------------------------------------------------------------------
     ReDim Preserve ZXbuffer(ZxOffset)
    If Not bNum And ZXbuffer(ZxOffset) <> 0 Then ZxOffset = ZxOffset + 1
    
     ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = 0

    ' Write current line infos in the line header saved in the LastLINE variable ------------
    ZXbuffer(LastLINE) = ((ZxOffset - LastLINE + 1) And &HFF)
    ZXbuffer(LastLINE + 1) = ((ZxOffset - LastLINE + 1) And &HFF00) / 256
    ZXbuffer(LastLINE + 2) = (CurNBLn And &HFF)
    ZXbuffer(LastLINE + 3) = (CurNBLn And &HFF00) / 256
    
    ' Line too big.
    'If (ZxOffset - LastLINE + 1) > &HFD Then
    'Disp_Err 22, " (" + Trim(Str(ZxOffset - LastLINE - 4)) + " chars)"
    'End If
        
    Prt_Trg = False
    TMPNum = ""
    bNum = False
    bHex = False
    bDEFINT = False
    FFTag = False
    bOn = False
    VarString = ""
    CommTag = 0
        
    If CurNBLn > 99999 Then
     Disp_Err 8
    End If
    
    
    ZxOffset = ZxOffset + 1
    
    lineCtr = lineCtr + 1
    ReDim Preserve Lines(lineCtr)
    Lines(UBound(Lines)) = CurNBLn
    

End Sub



Sub Disp_Err(ErrNumb As Byte, Optional Comment As String = "")

If Len(frmMain.Status) >= 27585 Then Exit Sub

Dim ErrStr As String
Dim ErrID As String
If ErrNumb <> 0 And ErrNumb <> 20 Then
ErrIndex = ErrIndex + 1
ErrID = "Error#" + Format(ErrIndex, "####") + ":"
If Len(frmMain.Status) <= (27585 - 17) Then frmMain.Status = frmMain.Status & ErrID
'FrmMain.Comments = FrmMain.Comments + "Error#" + Format(ErrIndex, "####") + ":"
End If

Select Case ErrNumb
Case 0
ErrStr = "Started." + vbCrLf
Case 1
ErrStr = "Label start line must be in the range 0 to 9999." + vbCrLf

Case 2
ErrStr = "Label line incr. must be in the range 1 to 9990." + vbCrLf

Case 3
ErrStr = "line " & InputLine & ": invalid block graphics. (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 4
ErrStr = "line " & InputLine & ": Non-mappable character in input (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 5
ErrStr = "Could not open input file." & vbCrLf

Case 6
ErrStr = "line " & InputLine & ": missing line number [" & Comment & "]" + vbCrLf

Case 7
ErrStr = "line " & InputLine & ": line #.[" & Comment & "] not greater than previous one" + vbCrLf

Case 8
ErrStr = "line " & InputLine & ": line #.[" & Comment & "] Line out of Basic range" + vbCrLf

Case 9
ErrStr = "line " & InputLine & ": line #. [" & Comment & "] already exists." + vbCrLf

Case 10
ErrStr = "Basic program too big ...(Up to 41700 Bytes) [" & Comment & " b.]" + vbCrLf + "(You had to trim your Basic program !... But, dont forget to reserve roms to the variable buffer !)" + vbCrLf

Case 11
ErrStr = "line " & InputLine & ": CPC Double convertion error [" & Comment & "] in Output (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 12
ErrStr = "Basic line " & Comment & ": Command code missing !" + vbCrLf

Case 13
ErrStr = "line " & InputLine & ": line #.[" & Comment & "] Illegal character in the line number." + vbCrLf


Case 20
ErrStr = "BASIC program length:" & Comment & vbCrLf & "Success." & vbCrLf

Case 21
ErrStr = "Failed : File error, can't open this file." + vbCrLf

Case 22
ErrStr = "line " & InputLine & ": [Basic line #" & Str(CurNBLn) & "] Line Excide 248 characters !!!" + Comment + vbCrLf

End Select
If (Len(frmMain.Status & ErrStr) >= 27585 And Len(frmMain.Status) < 27585) Then frmMain.Status = frmMain.Status & "Too many errors !" & vbCrLf
If Len(frmMain.Status & ErrStr) < 27585 Then frmMain.Status = frmMain.Status & ErrStr
'FrmMain.Comments = FrmMain.Comments + ErrStr
End Sub




Private Function Get_ASM(text As String) As String
Dim tmpchar As String
Dim TmpVal As Long
Dim ScanChar As String * 1
Dim BaseFlag As Byte
Dim JoChar As String * 1


' ASM_Buff() Main Byte buffer.
' Asm_OFF() Location in ASM_BUFFER.
' ASM_Add() Address where the buffer bloc is.
' ASM_lng() Lenght of bloc
' ASM_cnt Asm counter (0-xx)
' gAsmCNT Global asm counter.


If Trim(UCase(Left(text, 4))) = "ORG" Then
 text = Right(text, Len(text) - InStr(1, text, "("))
 
  tmpchar = Left(text, InStr(1, text, ")") - 1)
  text = Right(text, Len(text) - InStr(1, text, ")"))

 ReDim Preserve ASM_Add(ASM_cnt)
 If InStr(1, UCase(tmpchar), "H") > 0 Then
  If UCase(Right(tmpchar, 1)) = "H" Then
  tmpchar = Left(tmpchar, InStr(1, UCase(tmpchar), "H") - 1)
  Else
  tmpchar = Right(tmpchar, Len(tmpchar) - InStr(1, UCase(tmpchar), "H"))
  End If
  
  
  ASM_Add(ASM_cnt) = ASChex(tmpchar)
  
  Else
   ASM_Add(ASM_cnt) = Val(tmpchar)
  End If
  
 ReDim Preserve Asm_OFF(ASM_cnt)
 Asm_OFF(ASM_cnt) = gAsmCNT
 ReDim Preserve ASM_lng(ASM_cnt)
End If



'Retriev Base Specs.
   tmpchar = ""
   ScanChar = text
   Do While ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = "/" Or ScanChar = "-" Or ScanChar = " "
      text = Right(text, Len(text) - 1)
      If ScanChar = "]" Or Trim(text) = "" Then GoTo endscan1:
      ScanChar = text
   Loop
   
Select Case UCase(Left(text, 3))
    Case "HEX"
        BaseFlag = 1
    Case "DEC"
        BaseFlag = 2
    Case "BIN"
        BaseFlag = 3
    Case Else
        ErrIndex = ErrIndex + 1
        frmMain.Status = frmMain.Status & "Error#" & Format(ErrIndex, "####") & ":"
        frmMain.Status = frmMain.Status & "line " & InputLine & ": [" & UCase(Left(text, 3)) & "] invalid Base (BIN,HEX or DEC)." + vbCrLf
        Exit Function
End Select

    text = Right(text, Len(text) - 3)
    
Do Until Trim(text) = "" Or ScanChar = "]"
   tmpchar = ""
   ScanChar = text
   Do While ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = " " Or ScanChar = " "
      If Trim(text) <> "" Then
      text = Right(text, Len(text) - 1)
      ScanChar = text
      Else
      Exit Do
      End If
   Loop
         If ScanChar = "]" Then GoTo endscan1:

   Do
   
Select Case BaseFlag
   Case 1
     If Not Is_HEX(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      frmMain.Status = frmMain.Status & "Error#" & Format(ErrIndex, "####") & ":"
      frmMain.Status = frmMain.Status & "line " & InputLine & ": [" & ScanChar & "] invalid hexadecimal character." + vbCrLf
     Else
      tmpchar = tmpchar + ScanChar
     End If
    Case 2
      If Not Is_DEC(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      frmMain.Status = frmMain.Status & "Error#" & Format(ErrIndex, "####") & ":"
      frmMain.Status = frmMain.Status & "line " & InputLine & ": [" & ScanChar & "] invalid decimal character." + vbCrLf
     Else
      tmpchar = tmpchar + ScanChar
     End If
    Case 3
      If Not Is_BIN(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      frmMain.Status = frmMain.Status & "Error#" & Format(ErrIndex, "####") & ":"
      frmMain.Status = frmMain.Status & "line " & InputLine & ": [" & ScanChar & "] invalid binary character." + vbCrLf
     Else
      tmpchar = tmpchar + ScanChar
     End If
End Select

   If Trim(text) <> "" Then text = Right(text, Len(text) - 1)
        ScanChar = text
   Loop Until ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = " " Or ScanChar = "]"
      

   tmpchar = Trim(tmpchar)
   
   Select Case BaseFlag
   Case 1
   TmpVal = ASChex(tmpchar)
   Case 2
   TmpVal = Val(tmpchar)
   Case 3
   TmpVal = BinToDbl(tmpchar)
   End Select
   
   If TmpVal > 255 Then
    ErrIndex = ErrIndex + 1
      frmMain.Status = frmMain.Status & "Error#" + Format(ErrIndex, "####") & ":"
      frmMain.Status = frmMain.Status & "line " & InputLine & ": [" & tmpchar & "] too big." + vbCrLf
   Else
   
         ReDim Preserve ASM_Buff(gAsmCNT)
          ASM_Buff(gAsmCNT) = CByte(TmpVal)
          gAsmCNT = gAsmCNT + 1
          ASM_lng(ASM_cnt) = ASM_lng(ASM_cnt) + 1
         
   End If
   ScanChar = text
   If ScanChar = "]" Then
  
   End If
Loop

endscan1:

     If ScanChar = "]" Then text = Right(text, Len(text) - 1)
     
 'Asm_OFF(ASM_cnt) = ASM_lng(ASM_cnt) + ASM_lng(ASM_cnt - 1)
 
Get_ASM = text
ASM_cnt = ASM_cnt + 1

End Function





'Convert Zx byte chars codes to ZxText2P string.

Private Function Conv_SPGrByte(ZxBYTE As Byte) As String

Dim Conv_str As String
Conv_str = ""

  Select Case ZxBYTE
    Case &HC0
    Conv_str = "\" & Chr(&H22)
'    Case &H0
'    Conv_str = "\  "
    Case &H1
    Conv_str = "\' "
    Case &H2
    Conv_str = "\ '"
    Case &H3
    Conv_str = "\''"
    Case &H4
    Conv_str = "\. "
    Case &H5
    Conv_str = "\: "
    Case &H6
    Conv_str = "\.'"
    Case &H7
    Conv_str = "\:'"
    Case &H8
    Conv_str = "\##"
    Case &H9
    Conv_str = "\,,"
    Case &HA
    Conv_str = "\~~"
    Case &H80
    Conv_str = "\::"
    Case &H81
    Conv_str = "\.:"
    Case &H82
    Conv_str = "\:."
    Case &H83
    Conv_str = "\.."
    Case &H84
    Conv_str = "\':"
    Case &H85
    Conv_str = "\ :"
    Case &H86
    Conv_str = "\'."
    Case &H87
    Conv_str = "\ ."
    Case &H88
    Conv_str = "\@@"
    Case &H89
    Conv_str = "\;;"
    Case &H8A
    Conv_str = "\!!"
    Case Else
    Conv_str = ""
   End Select
   
   If ZxBYTE > 138 And ZxBYTE < 192 Then Conv_str = "%" & (ZxBYTE And 127)

       
Conv_SPGrByte = Conv_str


End Function



Function Remove_tabs(LineText As String) As String
Dim TmpLineText As String
Dim TabLoc As Long

TmpLineText = ""
TabLoc = 1

Do
TabLoc = InStr(TabLoc, LineText, vbTab)
If TabLoc = 0 Then Exit Do
If TabLoc <> 1 Then TmpLineText = TmpLineText & Left(LineText, TabLoc - 1) & " " Else TmpLineText = TmpLineText & " "
LineText = Right(LineText, Len(LineText) - TabLoc)
TabLoc = 1
Loop While TabLoc > 0
Remove_tabs = TmpLineText & LineText
End Function


Private Function GetFunc(TXT As String) As Long
Dim txt2 As String

            
Cmp_Decay = 1

'txt2 = LCase(Left(TXT, 2))
'If txt2 = "<>" Or txt2 = ">=" Or txt2 = "<=" Or txt2 = "**" Or bREM Then NewWord = True
'txt2 = LCase(Left(TXT, 1))
'If txt2 = Chr(192) Then Exit Function

If txt2 = Chr(20) Then NewWord = True
If NewWord = False Then Exit Function

GetFunc = -1

Cmp_Decay = 15
TXT = LCase(Left(TXT, 15))

'15 characters.
Select Case TXT
   Case "on error goto 0"
       GetFunc = 180
       Exit Function
End Select


Cmp_Decay = 9
TXT = LCase(Left(TXT, 9))

'9 characters.
Select Case TXT
   Case "randomize"
       GetFunc = 194
       Exit Function
End Select


Cmp_Decay = 8
TXT = LCase(Left(TXT, 8))

'8 characters.
Select Case TXT
   Case "on break"
       GetFunc = 179
       Exit Function

   Case "closeout"
       GetFunc = 137
        Exit Function

   Case "graphics"
       GetFunc = 222
       Exit Function
End Select


Cmp_Decay = 7
TXT = LCase(Left(TXT, 7))

'7 characters.
Select Case TXT
   Case "defreal"
       GetFunc = 143
       Exit Function

   Case "closein"
       GetFunc = 136
       Exit Function

   Case "openout"
       GetFunc = 183
       Exit Function

   Case "release"
       GetFunc = 196
        Exit Function

   Case "restore"
       GetFunc = 199
        Exit Function
End Select
Cmp_Decay = 6
TXT = LCase(Left(TXT, 6))

'6 characters.
Select Case TXT
   Case "symbol"
       GetFunc = 207
       Exit Function

   Case "tagoff"
       GetFunc = 209
       Exit Function

   Case "window"
       GetFunc = 216
       Exit Function

   Case "cursor"
       GetFunc = 225
       Exit Function

   Case "resume"
       GetFunc = 200
       Exit Function

   Case "return"
       GetFunc = 201
       Exit Function

   Case "border"
       GetFunc = 130
        Exit Function

   Case "defstr"
       GetFunc = 144
       Exit Function

   Case "delete"
       GetFunc = 146
       Exit Function

   Case "locate"
       GetFunc = 169
       Exit Function

   Case "memory"
       GetFunc = 170
       Exit Function

   Case "openin"
       GetFunc = 182
       Exit Function

   Case "origin"
       GetFunc = 184
       Exit Function

   Case "defint"
       GetFunc = 142
       Exit Function

End Select

Cmp_Decay = 5
TXT = LCase(Left(TXT, 5))

'5 characters.
Select Case TXT
   Case "chain"
       GetFunc = 133
       Exit Function

   Case "drawr"
       GetFunc = 149
       Exit Function

   Case "clear"
       GetFunc = 134
       Exit Function

   Case "erase"
       GetFunc = 155
       Exit Function

   Case "error"
       GetFunc = 156
       Exit Function

   Case "every"
       GetFunc = 157
        Exit Function

   Case "after"
       GetFunc = 128
       Exit Function

   Case "gosub"
       GetFunc = 159
       Exit Function

   Case "input"
       GetFunc = 163
       Exit Function

   Case "merge"
       GetFunc = 171
        Exit Function

   Case "plotr"
       GetFunc = 189
       Exit Function

   Case "mover"
       GetFunc = 175
       Exit Function

   Case "paper"
       GetFunc = 186
       Exit Function

   Case "on sq"
       GetFunc = 181
       Exit Function

   Case "print"
       GetFunc = 191
       Exit Function

   Case "sound"
       GetFunc = 204
       Exit Function

   Case "speed"
       GetFunc = 205
       Exit Function

   Case "troff"
       GetFunc = 210
       Exit Function

   Case "while"
       GetFunc = 214
       Exit Function

   Case "width"
       GetFunc = 215
       Exit Function

   Case "write"
       GetFunc = 217
       Exit Function

   Case "frame"
       GetFunc = 224
       Exit Function

   Case "renum"
       GetFunc = 199
       Exit Function
       
   Case "using"
       GetFunc = 237
       Exit Function
       
End Select


Cmp_Decay = 4
TXT = LCase(Left(TXT, 4))

'4 characters.
Select Case TXT
   Case "cont"
       GetFunc = 139
       Exit Function

   Case "data"
       GetFunc = 140
       Exit Function

   Case "draw"
       GetFunc = 148
       Exit Function

   Case "edit"
       GetFunc = 150
       Exit Function

   Case "else"
       GetFunc = 151
       Exit Function

   Case "goto"
       GetFunc = 160
       Exit Function

   Case "line"
       GetFunc = 166
       Exit Function

   Case "list"
       GetFunc = 167
        Exit Function

   Case "load"
       GetFunc = 168
       Exit Function

   Case "mid$"
       GetFunc = 172
       Exit Function

   Case "mode"
       GetFunc = 173
       Exit Function

   Case "move"
       GetFunc = 174
       Exit Function

   Case "next"
       GetFunc = 176
       Exit Function

   Case "auto"
       GetFunc = 129
       Exit Function

   Case "call"
       GetFunc = 131
       Exit Function

   Case "plot"
       GetFunc = 188
       Exit Function

   Case "poke"
       GetFunc = 190
       Exit Function

   Case "read"
       GetFunc = 195
       Exit Function

   Case "save"
       GetFunc = 203
       Exit Function

   Case "stop"
       GetFunc = 206
       Exit Function
       
   Case "step"
       GetFunc = 230
       Exit Function
       
   Case "swap"
       GetFunc = 231
       Exit Function
       
   Case "then"
       GetFunc = 235
       Exit Function
       
   Case "tron"
       GetFunc = 211
       Exit Function

   Case "wait"
       GetFunc = 212
       Exit Function

   Case "wend"
       GetFunc = 213
       Exit Function

   Case "zone"
       GetFunc = 218
       Exit Function

   Case "fill"
       GetFunc = 221
       Exit Function

   Case "mask"
       GetFunc = 223
       Exit Function
End Select

Cmp_Decay = 3
TXT = LCase(Left(TXT, 3))

'3 characters.
Select Case TXT
   Case "cat"
       GetFunc = 132
        Exit Function
 
   Case "cls"
       GetFunc = 138
        Exit Function
 
   Case "clg"
       GetFunc = 135
        Exit Function
 
   Case "def"
       GetFunc = 141
        Exit Function
 
   Case "deg"
       GetFunc = 145
        Exit Function
 
   Case "dim"
       GetFunc = 147
        Exit Function
 
   Case "end"
       GetFunc = 152
        Exit Function
 
   Case "ent"
       GetFunc = 153
        Exit Function
 
   Case "env"
       GetFunc = 154
        Exit Function
       
   Case "for"
       GetFunc = 158
        Exit Function
 
   Case "ink"
       GetFunc = 162
       Exit Function
   
   Case "key"
       GetFunc = 164
       Exit Function

   Case "let"
       GetFunc = 165
       Exit Function

   Case "new"
       GetFunc = 177
       Exit Function

   Case "out"
       GetFunc = 185
       Exit Function

   Case "pen"
       GetFunc = 187
       Exit Function

   Case "rad"
       GetFunc = 193
       Exit Function

   Case "rem"
       GetFunc = 197
       Exit Function

   Case "run"
       GetFunc = 202
       Exit Function

   Case "tab"
       GetFunc = 234
       Exit Function
       
   Case "tag"
       GetFunc = 208
       Exit Function
       
   Case "erl"
       GetFunc = 227
       Exit Function
       
   Case "spc"
       GetFunc = 229
       Exit Function
              
   Case "and"
       GetFunc = 250
       Exit Function
       
   Case "mod"
       GetFunc = 251
       Exit Function
       
   Case "xor"
       GetFunc = 253
       Exit Function
       
   Case "not"
       GetFunc = 254
       Exit Function
       
   Case "abs"
       GetFunc = 255
       Exit Function
'250 AND
'251 MOD
'252 OR
'253 XOR
'254 NOT
End Select


Cmp_Decay = 2
If Len(TXT) < 3 Then TXT = TXT & " "
TXT = LCase(Left(TXT, 3))
If Right(TXT, 1) = Chr(&HA) Or Right(TXT, 1) = Chr(&HD) Or Right(TXT, 1) = ":" Then TXT = LCase(Left(TXT, 2)) & " "

'2 characters.
Select Case TXT
   Case "di "
       GetFunc = 219
       Exit Function

   Case "ei "
       GetFunc = 220
        Exit Function
 
   Case "if "
       GetFunc = 161
        Exit Function
 
   Case "on "
       GetFunc = 178
       Exit Function
        
   Case "fn "
       GetFunc = 228
       Exit Function
       
   Case "or "
       GetFunc = 252
       Exit Function
       
   Case "to "
       GetFunc = 236
       Exit Function

End Select

 Cmp_Decay = 2
TXT = Left(TXT, 2)

'1 character.
Select Case TXT
'240 >=
    Case ">=", "=>"
    GetFunc = 240: Exit Function
'242 <>
    Case "<>", "><"
    GetFunc = 242: Exit Function
'243 <=
    Case "<=", "=<"
    GetFunc = 243: Exit Function
    
End Select
       
       
 Cmp_Decay = 1
TXT = Left(TXT, 1)

'1 character.
Select Case TXT
   Case "'"
       GetFunc = 192 ' =197 =Rem
        Exit Function
        
   Case "?"
       GetFunc = 191 ' =191 =PRINT
        Exit Function
 '001 :
 '   Case ":"
 '      GetFunc = 1
 '       Exit Function
End Select

If TXT = Chr(20) Then NewWord = True Else NewWord = False
End Function

Function GetFunc2(TXT As String) As Long
GetFunc2 = -1

Cmp_Decay = 8
TXT = LCase(Left(TXT, 8))

'8 characters.
Select Case TXT
        Case "copychr$"
       GetFunc2 = 126
       Exit Function
End Select

Cmp_Decay = 7
TXT = LCase(Left(TXT, 7))

'7 characters.
Select Case TXT
   Case "string$"
       GetFunc2 = 123
       Exit Function
End Select

Cmp_Decay = 6
TXT = LCase(Left(TXT, 6))

'6 characters.
Select Case TXT

   Case "space$"
       GetFunc2 = 22
       Exit Function

   Case "upper$"
       GetFunc2 = 28
       Exit Function

   Case "lower$"
       GetFunc2 = 17
       Exit Function

   Case "remain"
       GetFunc2 = 19
       Exit Function

   Case "inkey$"
       GetFunc2 = 67
       Exit Function
       
   Case "right$"
       GetFunc2 = 121
       Exit Function
   
End Select

Cmp_Decay = 5
TXT = LCase(Left(TXT, 5))

'5 characters.
Select Case TXT
   Case "error"
       GetFunc2 = -1
       Exit Function
       
   Case "input"
       GetFunc2 = -1
       Exit Function
       
   Case "log10"
       GetFunc2 = 16
       Exit Function

   Case "inkey"
       GetFunc2 = 10
       Exit Function

   Case "creal"
       GetFunc2 = 6
       Exit Function

   Case "himem"
       GetFunc2 = 66
       Exit Function
       
   Case "round"
       GetFunc2 = 122
       Exit Function
       
   Case "instr"
       GetFunc2 = 116
       Exit Function
       
   Case "left$"
       GetFunc2 = 117
       Exit Function
       
   Case "testr"
       GetFunc2 = 125
       Exit Function

End Select

Cmp_Decay = 4
TXT = LCase(Left(TXT, 4))

'4 characters.
Select Case TXT
   Case "peek"
       GetFunc2 = 18
       Exit Function

   Case "chr$"
       GetFunc2 = 3
       Exit Function

   Case "cint"
       GetFunc2 = 4
       Exit Function

   Case "time"
       GetFunc2 = 70
       Exit Function

   Case "xpos"
       GetFunc2 = 71
       Exit Function

   Case "ypos"
       GetFunc2 = 72
       Exit Function

   Case "derr"
       GetFunc2 = 73
       Exit Function
       
   Case "bin$"
       GetFunc2 = 113
       Exit Function
       
   Case "dec$"
       GetFunc2 = 114
       Exit Function
   
   Case "hex$"
       GetFunc2 = 115
       Exit Function
       
   Case "test"
       GetFunc2 = 124
       Exit Function
       
    
   Case "vpos"
       GetFunc2 = 127
       Exit Function

   Case "str$"
       GetFunc2 = 25
       Exit Function
       
End Select

Cmp_Decay = 3
TXT = LCase(Left(TXT, 3))

'3 characters.
Select Case TXT
   Case "abs"
       GetFunc2 = 0
       Exit Function

   Case "asc"
       GetFunc2 = 1
       Exit Function

   Case "atn"
       GetFunc2 = 2
       Exit Function

   Case "cos"
       GetFunc2 = 5
       Exit Function

   Case "exp"
       GetFunc2 = 6
       Exit Function
        
   Case "err"
       GetFunc2 = 65
       Exit Function
       
   Case "fix"
       GetFunc2 = 8
       Exit Function

   Case "fre"
       GetFunc2 = 9
       Exit Function

   Case "sgn"
       GetFunc2 = 20
       Exit Function

   Case "sin"
       GetFunc2 = 21
       Exit Function

   Case "sqr"
       GetFunc2 = 24
       Exit Function

   Case "tan"
       GetFunc2 = 26
       Exit Function

   Case "unt"
       GetFunc2 = 27
       Exit Function

   Case "val"
       GetFunc2 = 29
       Exit Function

   Case "inp"
       GetFunc2 = 11
       Exit Function

   Case "int"
       GetFunc2 = 12
       Exit Function

   Case "joy"
       GetFunc2 = 13
       Exit Function

   Case "len"
       GetFunc2 = 14
       Exit Function

   Case "log"
       GetFunc2 = 15
       Exit Function
       
   Case "eof"
       GetFunc2 = 64
       Exit Function
       
   Case "rnd"
       GetFunc2 = 69
       Exit Function
       
   Case "max"
       GetFunc2 = 118
       Exit Function
       
   Case "min"
       GetFunc2 = 119
       Exit Function
       
   Case "pos"
       GetFunc2 = 120
       Exit Function
      
End Select

Cmp_Decay = 2
TXT = LCase(Left(TXT, 2))

'2 characters.
Select Case TXT
    Case "sq"
       GetFunc2 = 23
       Exit Function
    Case "pi"
       GetFunc2 = 68
       Exit Function
End Select

End Function


' Internal function cut attributes "disk.TXT" = "disk"
Public Function Cut_attr(Char As String) As String
Cut_attr = Char
For cmp = Len(Char) To 1 Step -1
If Mid(Char, cmp, 1) = "." Then Cut_attr = Mid(Char, 1, cmp - 1): Exit For
If Mid(Char, cmp, 1) = "\" Then Cut_attr = Char: Exit For
Next cmp
End Function
' Internal function cut Name "c:\a\b\disk.TXT" = "disk.txt"
Public Function Cut_Name(Char As String) As String

Cut_Name = ""
For cmp = Len(Char) To 1 Step -1
If Mid(Char, cmp, 1) = "\" Then Exit For
Next cmp
Cut_Name = Right(Char, Len(Char) - cmp)
End Function


Function Is_DEC(Key As Integer) As Boolean
Is_DEC = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If (Key < &H30 Or Key > &H39) Then Is_DEC = False
End Function

Function Is_HEX(Key As Integer) As Boolean
Is_HEX = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If Not (Asc(UCase(Chr(Key))) > &H40 And Asc(UCase(Chr(Key))) < &H47) _
And Not (Key > &H2F And Key < &H3A) Then Is_HEX = False: GoTo Key_is_ok
Key_is_ok:
End Function

Function Is_BIN(Key As Integer) As Boolean
Is_BIN = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If Not (Key = vbKey0 Or Key = vbKey1 Or Key = vbKeyNumpad0 Or Key = vbKeyNumpad1) Then Is_BIN = False
End Function

Function ASChex(Strhex As String) As Long
If Len(Strhex) >= 8 Then ASChex = &HFFFF: Exit Function

Dim multi As String
Dim a As Integer
multi = 0
ASChex = 0
If Strhex = "" Then Exit Function

For a = Len(Strhex) To 1 Step -1
ASChex = ASChex + (Val("&h" & Mid(Strhex, a, 1)) * (16 ^ multi))
multi = multi + 1
Next

End Function

Function BinToDbl(Value As String) As Double
    'Convertir chane binaire en entier long
    '  Value$ - chane binaire , par exemple "0110101"
    '  Dez#   - Entier long (Type Double)
    Dim Dezimal As Double
    Dim MaxLen As Integer
    Dim b As Integer, X As Integer
  
    MaxLen = Len(Value)
    For X = 1 To MaxLen
        b = Val(Mid$(Value, X, 1))
        Dezimal = Dezimal + b * 2 ^ (MaxLen - X)
    Next
    BinToDbl = Dezimal
End Function

Function Is_ChrHEX(Key As String) As Boolean
Is_ChrHEX = True
' Is A-F and 0-9
If Not (Asc(UCase(Key)) > &H40 And Asc(UCase(Key)) < &H47) _
And Not (Asc(UCase(Key)) > &H2F And Asc(UCase(Key)) < &H3A) Then Is_ChrHEX = False

End Function

Function Is_AfHEX(Key As String) As Boolean
' Is A-F
Is_AfHEX = True
If Not (Asc(UCase(Key)) > &H40 And Asc(UCase(Key)) < &H47) Then Is_AfHEX = False
End Function

Function Is_ASCII(Key As String) As Boolean
Is_ASCII = True

If Not (Asc(UCase(Key)) > &H40 And Asc(UCase(Key)) < &H5B) _
And Not (Asc(Key) > &H2F And Asc(Key) < &H3A) Then Is_ASCII = False

End Function


Function Add_Num(STRnumber As String, Optional bOn As Boolean = False) As String
Dim Tmpstr As String, bNeg As Boolean, GetVals As CPC_Long
On Error GoTo errExit

'If CurNBLn = xxx Then
'Debug.Print
'End If

' ON DEC GOTO A,B,C,D...
If bOn Then
Add_Num = Chr(&H1E) + Chr((Val(STRnumber) And &HFFFF) - (Val(STRnumber) And &HFF00)) + Chr((Val(STRnumber) And &HFF00) \ &H100)
Exit Function
End If

If Len(STRnumber) > 1 Then Tmpstr = Right(STRnumber, Len(STRnumber) - 1) Else Tmpstr = STRnumber

Add_Num = ""

If InStr(1, STRnumber, ".") = 0 Then

 Select Case Left(STRnumber, 1)
            Case "&"
                    Add_Num = Chr(&H1C) + Chr((ASChex(Tmpstr) And &HFFFF) - (ASChex(Tmpstr) And &HFF00)) + Chr((ASChex(Tmpstr) And &HFF00) \ &H100)
                    Exit Function
            Case "%"
                    Add_Num = Chr(&H25) + Chr(BinToDbl(Tmpstr) And &HFFFF - (BinToDbl(Tmpstr) And &HFF00)) + Chr((BinToDbl(Tmpstr) And &HFF00) \ &H100)
                    Exit Function
 End Select

Debug.Print ZXbuffer(ZxOffset), ZXbuffer(ZxOffset - 1), ZXbuffer(ZxOffset - 2), ZXbuffer(ZxOffset - 3)

'If ZXbuffer(ZxOffset - 1) = 187 And Len(STRnumber) = 1 Then ZxOffset = ZxOffset + 1

Debug.Print ZXbuffer(ZxOffset - 2 + IIf(ZXbuffer(ZxOffset - 2) = 32, 1, 0) + IIf(ZXbuffer(ZxOffset - 1) = 44, 1, 0))
Select Case ZXbuffer(ZxOffset - 2 + IIf(ZXbuffer(ZxOffset - 2) = 32, 1, 0) + IIf(ZXbuffer(ZxOffset - 1) = 44, 1, 0)) + IIf(ZXbuffer(ZxOffset - 1) = 187, 1, 0)

Case 1, 146, 150, 151, 160, 167, 199, 200, 235, 202
    Add_Num = Chr(&H1E) + Chr((Val(STRnumber) And &HFFFF) - (Val(STRnumber) And &HFF00)) + Chr((Val(STRnumber) And &HFF00) \ &H100)

Case 159 ' Gosub
                        Select Case Val(STRnumber)
                        Case Is <= 32767
                            'Debug.Print Hex8(CLng(dbl2CPC2(Val(STRnumber)).Exp))
                            'Debug.Print (dbl2CPC2(Val(STRnumber)).man)
                            'Add_Num = Chr(&H1D) + Chr(CLng(dbl2CPC2(Val(STRnumber)).Exp)) & Chr(Val(Left(dbl2CPC2(Val(STRnumber)).man, 2)))
                           Add_Num = Chr(&H1E) + Chr((Val(STRnumber) And &HFFFF) - (Val(STRnumber) And &HFF00)) + Chr((Val(STRnumber) And &HFF00) \ &H100)
                         Case Else
                           Add_Num = Chr(&H1E) + Chr((Val(STRnumber) And &HFFFF) - (Val(STRnumber) And &HFF00)) + Chr((Val(STRnumber) And &HFF00) \ &H100)

                         End Select
' Add_Num

Case Else
       
            
                   If Val(ZXbuffer(ZxOffset - 1)) = &HF5 Then bNeg = True Else bNeg = False

                   Select Case Val(STRnumber)
                            
                            Case Is < 10 '&HF1 And ZXbuffer(ZxOffset - 2) = &HBB
                            Add_Num = Chr(Val(STRnumber) + &HE)
                            
                            Case Is < 256
                            Add_Num = Chr(&H19) + Chr(Val(STRnumber) And &HFF)
    
                            Case Is <= 32767
                            Add_Num = Chr(&H1A) + Chr(Val(STRnumber) And &HFFFF - (Val(STRnumber) And &HFF00)) + Chr((Val(STRnumber) And &HFF00) \ &H100)
                            
                            Case Is > 32767
                            ' long CPC Value.
                            GetVals = dbl2CPC(Val(STRnumber))
                            Add_Num = Chr(&H1F) & DBL2Chars(GetVals)
                   End Select


            
End Select
Else
' long CPC Value.
GetVals = dbl2CPC(Val(STRnumber))
Add_Num = Chr(&H1F) & DBL2Chars(GetVals)
End If
Exit Function
errExit:
Add_Num = Tmpstr
bHex = False

End Function

Function DBL2Chars(Dblvalues As CPC_Long) As String
'(1) 1F=Double tag
'(2) : GetVals.man (Byte 4)
'(3) : GetVals.man (Byte 3)
'(4) : GetVals.man (Byte 2)
'(5) : GetVals.man (Byte 1)
'(6) : (GetVals.Exp+1) (integer)
Dim i
DBL2Chars = ""
For i = 7 To 1 Step -2
DBL2Chars = DBL2Chars + Chr(Val("&H" & Mid(Dblvalues.man, i, 2)))
Next
DBL2Chars = DBL2Chars & Chr(Dblvalues.Exp)
End Function

Function Add_Varstr(VarString As String, Vtype As Byte)
If VarString = "" Then Exit Function

Dim Offset As Byte, Cnt


      Offset = 5 - IIf(Vtype = 4, 4, 0)
      
      
      ADD_String VarString, Offset
      
      '---------------------------------------------------------
      ' DEBUGG. - RESETED USING CLEAR FUNCTION -
      '---------------------------------------------------------
      Offset = 0
      
          ReDim Preserve ZXbuffer(ZxOffset + 2 + Len(VarString) - IIf(Vtype = 4, 2, 0))
      Select Case Vtype
      Case 1
      ZXbuffer(ZxOffset) = &HD
      Case 2
      ZXbuffer(ZxOffset) = &H3
      Case 3
      ZXbuffer(ZxOffset) = &H2
      Case 4 ' RSX
      ZXbuffer(ZxOffset) = 0
      End Select
      
      
      Select Case Vtype
      Case 1
       ZXbuffer(ZxOffset + 1) = Offset
 
      Case 2
       ZXbuffer(ZxOffset + 1) = Offset
      
      Case 4
      
      Case Else
      ZXbuffer(ZxOffset + 1) = 0
      End Select
      
      
       ZXbuffer(ZxOffset + 2) = 0
          
 For Cnt = 1 To Len(VarString) - 1
           ZXbuffer(ZxOffset + 2 - IIf(Vtype = 4, 2, 0) + Cnt) = CByte(Asc(Mid(VarString, Cnt, 1)))
 Next
 
          ZXbuffer(ZxOffset + 2 - IIf(Vtype = 4, 2, 0) + Cnt) = CByte(Asc(Right(VarString, 1)) + 128)
            
          ZxOffset = ZxOffset + 3 - IIf(Vtype = 4, 2, 0) + Cnt
          
End Function

Sub ClrSpc(CommTag As Byte)

' Remove Spaces.
Select Case CommTag
Case 170, 168
ZxOffset = ZxOffset - 1
Case Is > 239
ZxOffset = ZxOffset - 1
Case Else
End Select

End Sub


Function GetAlg(AlgStr As String) As Long

GetAlg = -1

Select Case Left(AlgStr, 1)
'32 :
 '   Case " "
 '   GetAlg = 32
'001 :
    Case ":"
    GetAlg = 1
'239 =
    Case "="
    GetAlg = 239
'241 <
    Case "<"
    GetAlg = 241
'238 >
    Case ">"
    GetAlg = 238
'244 +
    Case "+"
    GetAlg = 244
'245 -
    Case "-"
    GetAlg = 245
'246 *
    Case "*"
    GetAlg = 246
'247 /
    Case "/"
    GetAlg = 247
'248 up arrow
    Case "^"
    GetAlg = 248
'249 \
    Case "\"
    GetAlg = 249
End Select

Select Case Left(AlgStr, 2)
'240 >=
    Case ">=", "=>"
    GetAlg = 240: Cmp_Decay = 2
'242 <>
    Case "<>", "><"
    GetAlg = 242: Cmp_Decay = 2
'243 <=
    Case "<=", "=<"
    GetAlg = 243: Cmp_Decay = 2
End Select

End Function

Function dbl2CPC(Num As Single) As CPC_Long
 'On Error Resume Next
 
' * Converts a double to an inline-basic-style CPC floating point number.
' *
' * IN:      num  - Number to convert (dbl)
' * OUT:     &exp - Exponent (integer)
' * OUT:     &man - Mantissa (char)
' *

Dim IntNum As Double
Dim tmpint1 As Double
Dim tmpint2 As Double

Dim TmpVal As String
Dim Expon As Double

'    /* Special case for zero */
    If Num = 0 Then
    dbl2CPC.Exp = 0#
    dbl2CPC.man = 0#
     Exit Function
    End If
    

    
'    /* If negative work with the absolute value */
    If Num < 0 Then Num = -Num

If Num < 1 Then

Debug.Print
End If



dbl2CPC.Exp = Fix(Log(Num) / Log(2))


If dbl2CPC.Exp < -129 Or dbl2CPC.Exp > 126 Then Exit Function




If Num >= 1 Then
IntNum = ((Num / (2# ^ (dbl2CPC.Exp + Expon#))) * 2147483648#)
dbl2CPC.Exp = dbl2CPC.Exp + 129#
tmpint2 = IntNum - (Fix(IntNum / 65536#) * 65536#)  ' 65536=&h10000
If tmpint2 > 28 Then tmpint2 = tmpint2 - 28
tmpint1 = (IntNum / 65536#) And 32767#  ' 32767=&h7FFF
Else
IntNum = (((Num / (2# ^ (dbl2CPC.Exp + Expon#))) * 4294967296#))
If tmpint2 > 28 Then tmpint2 = tmpint2 - 56
Debug.Print 901943132# - IntNum#
dbl2CPC.Exp = 128# + CDbl(dbl2CPC.Exp)
tmpint2 = IntNum - Fix((IntNum / 65536#) * 65536#)  ' 65536=&h10000
tmpint1 = Fix(IntNum / 65536#) And 32767#  ' 32767=&h7FFF
End If




'If tmpint2 < 0 Then tmpint2 = 0

TmpVal = Hex16(UnsignedToLong(tmpint1)) & Hex16(UnsignedToLong(tmpint2))
    
    dbl2CPC.man = TmpVal

    Exit Function

Dbl_ERR:
    Disp_Err 11, Str(Num)
End Function

Public Function UnsignedToLong(Value As Double) As Long
    If Value < 0 Or Value >= OFFSET_4 Then Error 6
    
    If Value <= MAXINT_4 Then
        UnsignedToLong = Value
    Else
        UnsignedToLong = Value - OFFSET_4
    End If
End Function

Function Hex16(Value As Long) As String
If Value >= &H10000 Then Hex16 = "FFFF": Exit Function
If Value < &H10 Then
   Hex16 = "000" & Hex(Value): Exit Function
ElseIf Value < &H100 Then
   Hex16 = "00" & Hex(Value): Exit Function
ElseIf Value < &H1000 Then
   Hex16 = "0" & Hex(Value): Exit Function
End If
Hex16 = Hex8(Value \ &H100) & Hex8(Value - (Value \ &H100) * &H100)
End Function

Function Hex8(Value As Long) As String
If Value >= &H100 Then Hex8 = "FF": Exit Function
If Value < &H10 Then Hex8 = "0" & Hex(Value) Else Hex8 = Hex(Value)
End Function

Function ADD_String(VarString As String, Offset As Byte)
Dim Is_Here As Boolean
Dim Cnt As Integer
Dim TmpOFF As Long

Is_Here = False
For Cnt = 0 To UBound(Var_Array)
If VarString = Var_Array(Cnt) Then Is_Here = True: Exit For
Next

If Not Is_Here Then
Var_Array(Cnt - 1) = VarString: ReDim Preserve Var_Array(UBound(Var_Array) + 1)
Else
Cnt = Cnt + 1
End If

TmpOFF = IIf(Cnt > 1, (Cnt - 2) * 9, 0) + IIf(Cnt > 1, 5, 0)
On Error Resume Next
Offset = ((TmpOFF& And &HFF00) \ &H100) + (TmpOFF And &HFF)

Debug.Print VarString, Offset

End Function

Public Function Get_Path(Fname As String) As String
' Internal function cut Name "c:\a\b\disk.TXT" = "c:\a\b\"
If Fname = "" Then Get_Path = "": Exit Function

Get_Path = ""
For cmp = Len(Fname) To 1 Step -1
If Mid(Fname, cmp, 1) = "\" Then Exit For
Next cmp
Get_Path = Left(Fname, cmp)
End Function

Function dbl2CPC2(Num As Single) As CPC2_Long
 'On Error Resume Next
 
' * Converts a double to an inline-basic-style ZX81 floating point number.
' *
' * IN:      num  - Number to convert (dbl)
' * OUT:     &exp - Exponent (integer)
' * OUT:     &man - Mantissa (char)
' *

Dim IntNum As Double
Dim tmpint1 As Double
Dim tmpint2 As Double

Dim TmpVal As String
Dim Expon As Double

'    /* Special case for zero */
    If Num = 0 Then
    dbl2CPC2.Exp = 0#
    dbl2CPC2.man = 0#
     Exit Function
    End If
    

    
'    /* If negative work with the absolute value */
    If Num < 0 Then Num = -Num

dbl2CPC2.Exp = Fix(Log(Num) / Log(64))


If dbl2CPC2.Exp < -129 Or dbl2CPC2.Exp > 126 Then Exit Function

IntNum = ((Num / (2# ^ (dbl2CPC2.Exp))) * 2147483648#)


tmpint2 = IntNum - (Fix(IntNum / 65536#) * 65536#) - 28 ' 65536=&h10000
tmpint1 = (IntNum / 65536#) And 32767#  ' 32767=&h7FFF

If tmpint2 < 0 Then tmpint2 = 0

TmpVal = Hex16(UnsignedToLong(tmpint1)) ' & Hex16(UnsignedToLong(tmpint2))
    
    dbl2CPC2.man = TmpVal
    dbl2CPC2.Exp = dbl2CPC2.Exp
    Exit Function

Dbl_ERR:
    Disp_Err 11, Str(Num)
End Function

Sub Main()
Dim Comd As Variant, Cnt As Integer
Dim bBas As Boolean
Dim StrName() As String
Dim InName As String
Dim OutName As String
Dim Cntname As Integer
Dim bWin As Boolean

Cntname = 0
Comd = GetCommandLine
ComputerType = 2 ' Default=CPC6128
frmMain.Computer.ListIndex = ComputerType

Debug.Print Comd(0), UBound(Comd)

If UBound(Comd) = 0 Then ReDim Comd(1): Comd(1) = ""

If Comd(1) = "" Then
Load frmMain
frmMain.Show
Else

For Cnt = 1 To UBound(Comd)
Select Case Left(UCase(Comd(Cnt)), 4)
Case "-SNA"
bBas = False
Case "-BAS"
bBas = True
Case "-464"
frmMain.Computer.ListIndex = 0: ComputerType = 0
Case "-664"
frmMain.Computer.ListIndex = 1: ComputerType = 1
Case "-6128"
frmMain.Computer.ListIndex = 2: ComputerType = 2 ' CPC6128 by default.
Case "-WIN"
Load frmMain
bWin = True
Case Else
ReDim Preserve StrName(Cntname)
StrName(Cntname) = Comd(Cnt)
Cntname = Cntname + 1
End Select
Next Cnt
Cntname = Cntname - 1

If Cntname = -1 Then
MsgBox "Text file not found.", vbCritical, "Wrong text file name:"
        frmMain.MousePointer = 0
        Unload frmMain
        Reset
        End

End If

    If UBound(StrName) > 1 Then
        MsgBox "Wrong name." & vbCrLf & "(Please don't use spaces characters in the file name)", vbCritical, "Command arguments error:"
        frmMain.MousePointer = 0
        Unload frmMain
        Reset
        End
    End If
    
InName = StrName(0)

If Cntname = 0 Then
If bBas Then
OutName = StrName(0) & ".BAS"
Else
OutName = StrName(0) & ".SNA"
End If
Else

If bBas Then
If InStr(1, UCase(StrName(Cntname)), ".BAS") = 0 Then
OutName = StrName(Cntname) & ".BAS"
Else
OutName = StrName(Cntname)
End If

Else

If InStr(1, UCase(StrName(Cntname)), ".SNA") = 0 Then
OutName = StrName(Cntname) & ".SNA"
Else
OutName = StrName(Cntname)
End If

End If

End If

If Dir(StrName(0)) = "" Then
        MsgBox "Text file not found." & vbCrLf & "(Please don't use spaces characters in the file name)", vbCritical, "Wrong text file name:"
        frmMain.MousePointer = 0
        Unload frmMain
        Reset
        End
End If

gAsmCNT = 0
ASM_cnt = 0

ReDim ASM_Buff(0)
ASM_Buff(0) = 0

ReDim Asm_OFF(0)
Asm_OFF(0) = 0


ReDim ASM_lng(0)
ASM_lng(0) = 0

ReDim ASM_Add(0)
ASM_Add(0) = 0


ReDim Var_Array(0)

frmMain.MousePointer = 11
frmMain.InputTXT = InName

If bBas Then
frmMain.OutputTXTbas = OutName
Else
frmMain.OutputTXTsna = OutName
End If

If bWin Then frmMain.Show: frmMain.MousePointer = 0: GoTo comm_err

frmMain.Open_TextFile InName
frmMain.MousePointer = 0
Unload frmMain
End If
comm_err:

End Sub


' VB5 HELP example.
Function GetCommandLine(Optional MaxArgs)

    'Dclare les variables.
    Dim C, CmdLine, CmdLnLen, InArg, i, NumArgs, Getcar As String * 1
    'Vrifie si MaxArgs a t spcifi.
    If IsMissing(MaxArgs) Then MaxArgs = 10
    'Dfinit un tableau au format appropri.
    ReDim ArgArray(MaxArgs)
    NumArgs = 0: InArg = False
    
       
    'Rcupre les arguments de ligne de commande.
    CmdLine = ""
    For i = 1 To Len(Command())
    Getcar = Mid(Command(), i, 1)
    If Getcar <> Chr(34) Then CmdLine = CmdLine + Getcar Else CmdLine = CmdLine + " "
    Next
    

    CmdLnLen = Len(CmdLine)
    'Analyse de la ligne de commande caractre
    ' par caractre.
    For i = 1 To CmdLnLen

C = Mid(CmdLine, i, 1)
        'Analyse de caractres despacement ou
        'de tabulations.
        If (C <> " " And C <> vbTab) Then
            'Ni espace ni tabulation.
            'Vrifie une ventuelle prsence
            'dans largument.
            If Not InArg Then
            'Le nouvel argument commence.
            'Vrifie si  les arguments ne sont pas
            'trop nombreux.
                If NumArgs = MaxArgs Then Exit For
                    NumArgs = NumArgs + 1
                    InArg = True

End If
            'Ajoute un caractre  largument courant.
            ArgArray(NumArgs) = ArgArray(NumArgs) + C
        Else
            'Recherche un espace ou une tabulation.
            'InArg flag prend la valeur False.
            InArg = False
        End If
    Next i
    'Redimensionne le tableau pour quil puisse
    'contenir les arguments.
    ReDim Preserve ArgArray(NumArgs)
    'Renvoie le tableau dans le nom de fonction.
    GetCommandLine = ArgArray()
End Function

Function Sp_Char(Char As String, LngTag As Byte) As String

Sp_Char = Char

Select Case LngTag
Case 1 ' English.(EN)
    Select Case Char
    Case "@"
    Sp_Char = Chr(&H40)
    Case "\"
    Sp_Char = Chr(&H5C)
    Case "~"
    Sp_Char = Chr(&H5E)
    Case "{"
    Sp_Char = Chr(&H7B)
    Case "|"
    Sp_Char = Chr(&H7C)
    Case "}"
    Sp_Char = Chr(&H7D)
    End Select
Case 2 ' Franais.(FR)
    Select Case Char
    Case "", "@"
    Sp_Char = Chr(&H40)
    Case "", "\"
    Sp_Char = Chr(&H5C)
    Case "^"
    Sp_Char = Chr(&H5E)
    Case "", "{"
    Sp_Char = Chr(&H7B)
    Case "", "}"
    Sp_Char = Chr(&H7D)
    Case "", "", "|"
    Sp_Char = Chr(&H7C)
    
    End Select
Case 3 'DEUTSCH(DE)

End Select

End Function


Sub Save_DSK(DSK_Name As String)
On Error GoTo error_Rpt
Dim Cat_DSK As DirEntry
'Copy empty disk.

If Dir(DSK_Name) <> "" And frmMain.Write2.ListIndex = 1 Then
Kill DSK_Name
End If
If frmMain.Write2.ListIndex <> 2 Then
FileCopy App.path & "\datas\Blk_DISK.DSK", DSK_Name
Else
If Dir(DSK_Name) <> "" Then

frmMain.Status = frmMain.Status & vbCrLf & "Unable to find or open " & DSK_Name & "" & vbCrLf & "A new file have been created !" & vbCrLf

End If
End If



Exit Sub

error_Rpt:
Debug.Print Err.Description
Disp_Err 21
Reset
Err.Clear
frmMain.Status = frmMain.Status & vbCrLf & "Process aborted." & vbCrLf
End Sub
Sub GetFreeSectors()

End Sub
Sub WriteAsector(IDBLOC As Integer, BuffBloc As Integer)
'Sectors=42
'SectorSize = 4864 (- header(256))=4608
'Clusters =512 (9*512)
Dim SOffset As Long, Side As Long
Dim DSK_Header As Long, DSK_TrackHeader As Long
Dim G_Track As Long, F_Track
Exit Sub
' [ Dsk Header    (256b)
' -------------
' [ Track Header  (256b)
' [ sector n      (256b) Side0
' [ sector n      (256b) Side1
' [ sector n+1    (256b) Side0
' [ sector n+1    (256b) Side1
' (...)
' [ sector n+8    (256b) Side0
' [ sector n+8    (256b) Side1
'
' ... next Track Header  (256b) * 41

Side = 0
DSK_Header = 256
DSK_TrackHeader = 256
G_Track = IDBLOC \ 9
F_Track = ((IDBLOC Mod 9) * 2) * 512
SOffset = DSK_Header + ((DSK_TrackHeader + 4608) * (IDBLOC * G_Track)) + (((IDBLOC Mod 9) * 2) * 512)

Debug.Print DSK_Header + (((DSK_TrackHeader + 4608) * (G_Track * 2))), 24576
Debug.Print SOffset, 26370
End Sub


Function TestLineNbr(LineStr As String) As Boolean
Dim a
Dim TestStr As String
LineStr = LineStr
Dim TmpCar As Byte
TestLineNbr = True

For a = 1 To Len(LineStr)
TmpCar = Asc(Mid(LineStr, a, 1))
If TmpCar < 48 Or TmpCar > 57 Then TestLineNbr = False: Exit For
Next
End Function

Function RebuildLineNbr(LineStr As String) As String
Dim a
Dim TestStr As String
LineStr = LineStr
Dim TmpCar As Byte


TestStr = ""
For a = 1 To Len(LineStr)
TmpCar = Asc(Mid(LineStr, a, 1))
If TmpCar < 48 Or TmpCar > 57 Then
Select Case UCase(Chr(TmpCar))
Case "O", "Q", "@", "U", Chr(210), Chr(211), Chr(212), Chr(213), Chr(214), Chr(216), Chr(217), Chr(218), Chr(219), Chr(220), Chr(240), Chr(242), Chr(243), Chr(244), Chr(245), Chr(246), Chr(248), Chr(249), Chr(250), Chr(251), Chr(252), Chr(169)
TestStr = TestStr + "0"
Case "I", "L", "J", Chr(204), Chr(205), Chr(206), Chr(207), Chr(124), Chr(134), Chr(33), Chr(40), Chr(41)
TestStr = TestStr + "1"
Case "B"
TestStr = TestStr + "8"
Case "G"
TestStr = TestStr + "0"
End Select
If Chr(TmpCar) = "b" Then TestStr = TestStr + "6"
If Chr(TmpCar) = "q" Then TestStr = TestStr + "9"
If Chr(TmpCar) = "g" Then TestStr = TestStr + "9"
Else
TestStr = TestStr + Chr(TmpCar)
End If
Next
RebuildLineNbr = TestStr
End Function



